From 1e9620197ff9bf590ca5af2d8f59c1121c9755cb Mon Sep 17 00:00:00 2001
From: Jari Aalto <jari.aalto@cante.net>
Date: Thu, 18 Sep 2008 15:55:26 +0300
Subject: [PATCH] chkrootkit: (printn): Use printf if available.

Signed-off-by: Jari Aalto <jari.aalto@cante.net>
---
 chkrootkit |   30 +++++++++++++++++++++++++++---
 1 files changed, 27 insertions(+), 3 deletions(-)

diff --git a/chkrootkit b/chkrootkit
index 7999b6f..0875a77 100755
--- a/chkrootkit
+++ b/chkrootkit
@@ -2607,10 +2607,34 @@ chk_telnetd () {
 
 printn ()
 {
-    if `${echo} "a\c" | ${egrep} c >/dev/null 2>&1` ; then
-        ${echo} -n "$1"
+    printf="use printf"
+    printf_fmt="%-60s"
+
+    if [ ! "$PRINTF_BIN" ]; then
+	# This is first time call to use. Check environment and
+	# define this global.
+
+	PRINTF_BIN=`which printf 2> /dev/null`
+
+	# Set to dummy, if not found
+	[ ! "$PRINTF_BIN" ] && PRINTF_BIN="not exists"
+
+	# We're done, and won't enter this if-case any more
+    fi
+
+    # Some messages are continued, so don't use printf
+    case "$1" in
+	*exec*|*bogus*) printf="" ;;
+    esac
+
+    if [ "$PRINTF_BIN" ] && [ "$printf" ]; then
+	$PRINTF_BIN "$printf_fmt" "$1"
     else
-        ${echo} "${1}\c"
+	if `${echo} "a\c" | ${egrep} c >/dev/null 2>&1` ; then
+	    ${echo} -n "$1"
+	else
+	    ${echo} "${1}\c"
+	fi
     fi
 }
 
-- 
1.5.6.5

